﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Web;
using Microsoft.ServiceBus;
using Microsoft.Win32;
using System.Runtime.InteropServices;
using System.IO;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using System.Threading;
using System.Configuration;

namespace smarx.AnnoySmarx
{
    [ServiceContract(Name = "AnnoySmarxContract", Namespace = "http://annoy.smarx.com/REST")]
    public interface IAnnoySmarxContract
    {
        [OperationContract, WebGet]
        Stream SetWallpaper(Guid id);
    }

    [ServiceBehavior(Name = "AnnoySmarxService", Namespace = "http://annoy.smarx.com/")]
    public class AnnoySmarxService : IAnnoySmarxContract
    {
        private static int n = 0;

        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        static extern int SystemParametersInfo(int uAction, int uParam, string lpvParam, int fuWinIni);

        public Stream SetWallpaper(Guid id)
        {
            WebOperationContext.Current.OutgoingResponse.ContentType = "text/plain";
            string path = Path.GetFullPath(@"wallpapers\" + id.ToString());
            Console.WriteLine(string.Format("[{0}] Wallpaper {1}", DateTime.Now, id));
            var key = Registry.CurrentUser.OpenSubKey("Control Panel\\Desktop", true);
            key.SetValue(@"WallpaperStyle", "1");
            key.SetValue(@"TileWallpaper", "0");
            SystemParametersInfo(20, 0, path, 3);
            return new MemoryStream(Encoding.ASCII.GetBytes(string.Format("You changed my wallpaper to {0}.  That was really annoying.  Please don't do it again.  You're annoyer #{1} since last start.", id, n++)));
        }
    }

    class Program
    {
        static void DownloadForever(string connectionString)
        {
            Console.WriteLine(string.Format("Downloading to {0}...", Path.GetFullPath("wallpapers")));
            var account = CloudStorageAccount.Parse(connectionString);
            var container = account.CreateCloudBlobClient().GetContainerReference("wallpapers");
            Directory.CreateDirectory("wallpapers");
            new Thread(new ThreadStart(() =>
            {
                while (true)
                {
                    foreach (var blob in container.ListBlobs())
                    {
                        if (!File.Exists(@"wallpapers\" + blob.Uri.Segments.Last()))
                        {
                            Console.WriteLine("Downloading " + blob.Uri.Segments.Last());
                            ((CloudBlob)blob).DownloadToFile(@"wallpapers\" + blob.Uri.Segments.Last());
                        }
                    }
                    Thread.Sleep(TimeSpan.FromSeconds(10));
                }
            })).Start();
        }

        static void Main(string[] args)
        {
            DownloadForever(ConfigurationManager.AppSettings["DataConnectionString"]);

            string serviceNamespace = ConfigurationManager.AppSettings["ServiceBusNamespace"];
            Uri address = ServiceBusEnvironment.CreateServiceUri("https", serviceNamespace, "AnnoySmarx");
            WebServiceHost host = new WebServiceHost(typeof(AnnoySmarxService), address);
            host.Open();
            Console.WriteLine("Listening at " + address);
            Console.ReadLine();
            host.Close();
        }
    }
}