﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure.ServiceRuntime;
using System.Text;

namespace AnnoySmarx_Web.Controllers
{
    public class AdminController : Controller
    {
        protected override void OnAuthorization(AuthorizationContext filterContext)
        {
            var authHeader = filterContext.HttpContext.Request.Headers["Authorization"];
            if ((authHeader != null) && (authHeader.StartsWith("Basic")))
            {
                // Parse username and password out of the HTTP headers
                authHeader = authHeader.Substring("Basic".Length).Trim();
                byte[] authHeaderBytes = Convert.FromBase64String(authHeader);
                authHeader = Encoding.UTF7.GetString(authHeaderBytes);
                string userName = authHeader.Split(':')[0];
                string password = authHeader.Split(':')[1];
                if (password == RoleEnvironment.GetConfigurationSettingValue("AdminPassword"))
                {
                    return;
                }
            }
            filterContext.HttpContext.Response.StatusCode = 401;
            filterContext.HttpContext.Response.AppendHeader("WWW-Authenticate", "Basic realm=\"admin\"");
            filterContext.Result = new HttpUnauthorizedResult();
        }

        public ActionResult Upload()
        {
            return View();
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Create()
        {
            Guid guid = Guid.NewGuid();
            var account = CloudStorageAccount.FromConfigurationSetting("DataConnectionString");
            var container = account.CreateCloudBlobClient().GetContainerReference("wallpapers");
            var file = Request.Files[0];
            var blob = container.GetBlobReference(guid.ToString());
            blob.Properties.ContentType = file.ContentType;
            blob.UploadFromStream(file.InputStream);
            account.CreateCloudQueueClient().GetQueueReference("incoming").AddMessage(new CloudQueueMessage(guid.ToString()));
            return RedirectToAction("index", "home");
        }
    }
}